/*
Copyright 2015-2016, Manuel Bichler
WWW: <http://dbai.tuwien.ac.at/proj/lpopt/>

This file is part of lpopt.

lpopt is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

lpopt is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with lpopt.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "parser.hh"

#include "../asp-domain/asp-domain.hpp"


namespace parser {

class Driver
{
  friend class parser::Parser; // to set program and call error function
public:
	Driver(std::istream *stream);
	~Driver();
	domain::Program* parse(); // parse from the constructor-given input stream and return the parsed ASP program. Caller is responsible for deleting the program object.

private:
	void error(const parser::location& l, const std::string& m);
	std::istream *stream;
	domain::Program* program; // set by the parser
};

} // namespace parser
